//Timea, Seline, Amaïa
//2E
//Help Felix


int phase = 1; //1: Startbildschirm; 2: Steuerung; 3: Spiel


PImage backgroundImage;
PImage characterImage;
PImage characterImage2;
PImage obstacleImage1;
PImage obstacleImage2;
PImage coinImage;


float x = 50;
float y = 300;
float velocityX = 0;
float velocityY = 0;
float gravity = 1;

boolean isJumping = false;

ArrayList<Obstacle> obstacles = new ArrayList<Obstacle>();
ArrayList<Coin> coins = new ArrayList<Coin>();
int score = 0;

int minDistance = 200;
int maxDistance = 400;
int lastObstacleX1 = width + 50;
int lastObstacleX2 = lastObstacleX1 + floor(random(minDistance, maxDistance));

boolean isCharacterState1 = true;  // Boolean variable to track the character state
int lastStateChangeTime = 0;  // Variable to store the last state change time

void setup() {
  size(800, 600);
  backgroundImage = loadImage("background.jpg");
  characterImage = loadImage("character.png");
  characterImage2 = loadImage("character2.png");  // Load the second character state image
  obstacleImage1 = loadImage("obstacle.png");
  obstacleImage2 = loadImage("obstacle2.png");
  coinImage = loadImage("coin.png");
  obstacleImage1.resize(105, 115);
  obstacleImage2.resize(90, 60);
  coinImage.resize(100, 100);

  lastObstacleX1 = width + 50;
  lastObstacleX2 = lastObstacleX1 + floor(random(minDistance, maxDistance));

   obstacles.add(new Obstacle(lastObstacleX1, height - obstacleImage1.height, obstacleImage1));
  
  // Generate the second obstacle with the minimum distance constraint
  float obstacle2X = lastObstacleX1 + floor(random(minDistance, maxDistance)) + characterImage.width * 4;
  obstacles.add(new Obstacle(obstacle2X, height - obstacleImage2.height, obstacleImage2));
  spawnRandomObstacle();
}


void draw() {
  {
  background(255);
  if(phase == 1)
  {
   
    
      fill(0);
     textSize(40);
    text("Help Felix",330,100);
    textSize(20);
    fill(250,100,200);
    square(245,240,100);
    square(455, 240, 100);
    fill(255);
    text("Steuerung",250,300);
    text("Spiel",480,300);
    
   
    
    if(mousePressed && mouseButton == LEFT)
    {
      if(mouseX >= 200 && mouseX <= 300 && mouseY >= 240 && mouseY <= 340)
      {
        phase = 2;
      }
      else if(mouseX >= 400 && mouseX <= 500 && mouseY >= 240 && mouseY <= 340)
      {
        phase = 3;
      }
    }
  }
  else if(phase == 2)
  {
    background(250,100,200);
    fill(0);
    textSize(30);
    text("Die Steuerung",305,200);
    textSize(20);
    text("-Um zu starten drücken sie auf Spielen.",50,300);
    text("-Um auf die homepage zu gehen mussen sie auf R drücken.", 50,330); 
    text("-Wenn Sie A drücken, geht Felix zurück.",50,360);
    text("-Wenn Sie D drücken, geht Felix vorwärts.",50,390);
    text("-Wenn Sie E drücken, springt Felix.",50,420);
    
    
    //Klick erkennen
    if(keyPressed && key == 'r')
    {
      phase = 1;
      background(0);
    }
    
  }
  if(phase == 3)
  {
    
    
  background(backgroundImage);
  
  // Check if it's time to change character state
  if (millis() - lastStateChangeTime >= 400) {
    isCharacterState1 = !isCharacterState1;
    lastStateChangeTime = millis();
  }
  
  // Display character based on current state
  if (isCharacterState1) {
    image(characterImage, x, y);
  } else {
    image(characterImage2, x, y);
  }
  
  // Movement
  velocityY += gravity;
  x += velocityX;
  y += velocityY;
  
  // Limit character movement within the screen
  x = constrain(x, 0, width - characterImage.width);

  // Collisions with ground
  if (y + characterImage.height > height) {
    y = height - characterImage.height;
    velocityY = 0;
    isJumping = false;
  }

  // Collisions with obstacles
  for (int i = obstacles.size() - 1; i >= 0; i--) {
    Obstacle o = obstacles.get(i);
    o.update();
    o.display();
    if (o.hits(x, y, characterImage.width, characterImage.height)) {
      resetGame();
    }
    if (o.isOffscreen()) {
      obstacles.remove(i);
      spawnRandomObstacle();
      spawnCoin();
    }
  }

  // Coins
  for (int i = coins.size() - 1; i >= 0; i--) {
    Coin c = coins.get(i);
    c.update();
    c.display();
    if (c.hits(x, y, characterImage.width, characterImage.height)) {
      coins.remove(i);
      score++;
    }
    if (c.isOffscreen()) {
      coins.remove(i);
    }
  }

  // Display score
  textSize(32);
  fill(255);
  text("Score: " + score, 20, 40);

  // Controls
  if (keyPressed && key == 'e' && !isJumping) {
    velocityY = -25;
    isJumping = true;
  }
  if (keyPressed && key == 'd') {
    velocityX = 5;
  }
  if (keyPressed && key == 'a') {
    velocityX = -5;
  }
}



    //Klick erkennen
    if(keyPressed && key == 'r')
    {
      phase = 1;
      background(0);
    }
  }
}

void spawnRandomObstacle() {
  if (random(1) < 0.5) {
    float obstacleX = lastObstacleX2 + floor(random(minDistance, maxDistance));
    obstacles.add(new Obstacle(obstacleX, height - obstacleImage1.height, obstacleImage1));
  } else {
    float obstacleX = lastObstacleX2 + floor(random(minDistance, maxDistance));
    obstacles.add(new Obstacle(obstacleX, height - obstacleImage2.height, obstacleImage2));
  }
}

void resetGame() {
  x = 50;
  y = 300;
  velocityX = 0;
  velocityY = 0;
  obstacles.clear();
  coins.clear();
  lastObstacleX1 = width + floor(random(minDistance, maxDistance));
  lastObstacleX2 = lastObstacleX1 + floor(random(minDistance, maxDistance));
  obstacles.add(new Obstacle(lastObstacleX1, height - obstacleImage1.height, obstacleImage1));
  float obstacle2X = lastObstacleX1 + floor(random(minDistance, maxDistance)) + characterImage.width * 2;
  obstacles.add(new Obstacle(obstacle2X, height - obstacleImage2.height, obstacleImage2));
  score = 0;
  isJumping = false; // otherwise I cannot jump after the game restart
}

void spawnCoin() {
  coinImage.resize(120, 100);
  float coinY = random(height / 2, height - coinImage.height);
  coins.add(new Coin(lastObstacleX1, coinY));
}

class Obstacle {
  float x;
  float y;
  float speed = 5;
  PImage obstacleImage;

  Obstacle(float x, float y, PImage obstacleImage) {
    this.x = x;
    this.y = y;
    this.obstacleImage = obstacleImage;
  }

  void update() {
    x -= speed;
  }

  void display() {
    image(obstacleImage, x, y);
  }

  boolean hits(float px, float py, float pw, float ph) {
    return (px + pw > x && px < x + obstacleImage.width && py + ph > y && py < y + obstacleImage.height);
  }

  boolean isOffscreen() {
    return x < -obstacleImage.width;
  }
}

class Coin {
  float x;
  float y;
  float speed = 5;

  Coin(float x, float y) {
    this.x = x;
    this.y = y;
  }

  void update() {
    x -= speed;
  }

  void display() {
    image(coinImage, x, y);
  }

  boolean hits(float px, float py, float pw, float ph) {
    return (px + pw > x && px < x + coinImage.width && py + ph > y && py < y + coinImage.height);
  }

  boolean isOffscreen() {
    return x < -coinImage.width;
  }
}
